	.org $808000
	.hirom	off
	.mem 16
	.index 16
	.detect on
	.optimize off

font    	equ	$0A
charset		equ	$81e4
INI_X		equ	32	; es la posicin de la pantalla en pxeles donde queremos que empiece el texto
INI_Y		equ	64	; es preferible que estos valores decimales sean mltiplos de 8; rango [0,248]

POS_X		equ	$4D
POS_Y		equ	$4A
FUENTE		equ	$44
DESTINO		equ	$40
FINAL_TEXTO	equ	$0000
FINAL_LINEA	equ	$0005
OFFSET_A	equ	$0010
TAMANYO_FONT	equ	$0C40

RAM_txt		equ	$7EF800	; posicin en RAM donde se guarda el texto a sacar por pantalla tras el MTE
ANCHO_LINEA	equ	$7EF010	; esta variable contiene la anchura acumulada de todas las letras de 1 lnea
FLAG		equ	$7EF00E
OFFSET_INI	equ	$7EF00D
VALOR_INI	equ	$7EF00C
VRAM_POS	equ	$7EF00A	; puntero que indica la posicin en VRAM donde empezamos a escribir
ANCHO_TILE	equ	$7EF008	; 8 bits para guardar la anchura de la letra que estamos mostrando
NEW_PATRON	equ	$7EF006	; 8 bits que indican qu desplazamiento tendr la siguiente tile
PATRON		equ	$7EF004	; 8 bits que indican qu desplazamiento hay que aplicar al tile actual
cnt_tile	equ	$7EF002	; son 16 bits
count		equ	$7EF000
RAM_tiles	equ	$7E9000	; posicin en RAM donde se guardan los tiles de la fuente en orden y con VWF
DESP_tile	equ	$7E8180	; aqu se guardan las dos tiles en que se convierte la tile ya desplazada
TEMP_tile	equ	$7E8080	; aqu se guarda de forma temporal la tile que se va a desplazar
NUM_TILES	equ	$7E807E

start   sei
	phk             ;GET THE CURRENT BANK AND STORE ON staCK
	plb             ;GET VALUE OFF staCK AND MAKE IT THE CURRENT
			;PROGRAMMING BANK
	clc             ;CLEAR CARRY BIT
	xce             ;NATIVE 16 BIT MODE (NO 6502 EMULATION!)

;==========================================================================
;  INICIALIZACIN DE LOS REGISTROS DE LA SNES (esto siempre es igual)
;==========================================================================
;
	   rep #$30
	   lda #$0000
	   tcd		; el puntero de pgina directa se pone apuntando a $0000
	   lda #charset
	   sta font
	   sep #$30     ; X,Y,A are 8 bit numbers
	   lda #$8F     ; screen off, full brightness
	   sta $2100    ; brightness + screen enable register
	   lda #$00     ;
	   sta $2101    ; Sprite register (size + address in VRAM)
	   sta $2102    ; Sprite registers (address of sprite memory [OAM])
	   sta $2103    ;    ""                       ""
	   sta $2105    ; Graphic mode register
	   sta $2106    ; Mosaic register
	   sta $2107    ; Plane 0 map VRAM location
	   sta $2108    ; Plane 1 map VRAM location
	   sta $2109    ; Plane 2 map VRAM location
	   sta $210A    ; Plane 3 map VRAM location
	   sta $210B    ; Plane 0+1 Tile data location
	   sta $210C    ; Plane 2+3 Tile data location
	   sta $210D    ; Plane 0 scroll x (first 8 bits)
	   sta $210D    ; Plane 0 scroll x (last 3 bits) #$0 - #$07ff
	   sta $210E    ; Plane 0 scroll y (first 8 bits)
	   sta $210E    ; Plane 0 scroll y (last 3 bits) #$0 - #$07ff
	   sta $210F    ; Plane 1 scroll x (first 8 bits)
	   sta $210F    ; Plane 1 scroll x (last 3 bits) #$0 - #$07ff
	   sta $2110    ; Plane 1 scroll y (first 8 bits)
	   sta $2110    ; Plane 1 scroll y (last 3 bits) #$0 - #$07ff
	   sta $2111    ; Plane 2 scroll x (first 8 bits)
	   sta $2111    ; Plane 2 scroll x (last 3 bits) #$0 - #$07ff
	   sta $2112    ; Plane 2 scroll y (first 8 bits)
	   sta $2112    ; Plane 2 scroll y (last 3 bits) #$0 - #$07ff
	   sta $2113    ; Plane 3 scroll x (first 8 bits)
	   sta $2113    ; Plane 3 scroll x (last 3 bits) #$0 - #$07ff
	   sta $2114    ; Plane 3 scroll y (first 8 bits)
	   sta $2114    ; Plane 3 scroll y (last 3 bits) #$0 - #$07ff
	   lda #$80     ; increase VRAM address after writing to $2119
	   sta $2115    ; VRAM address increment register
	   lda #$00
	   sta $2116    ; VRAM address low
	   sta $2117    ; VRAM address high
	   sta $211A    ; Initial Mode 7 setting register
	   sta $211B    ; Mode 7 matrix parameter A register (low)
	   lda #$01
	   sta $211B    ; Mode 7 matrix parameter A register (high)
	   lda #$00
	   sta $211C    ; Mode 7 matrix parameter B register (low)
	   sta $211C    ; Mode 7 matrix parameter B register (high)
	   sta $211D    ; Mode 7 matrix parameter C register (low)
	   sta $211D    ; Mode 7 matrix parameter C register (high)
	   sta $211E    ; Mode 7 matrix parameter D register (low)
	   lda #$01
	   sta $211E    ; Mode 7 matrix parameter D register (high)
	   lda #$00
	   sta $211F    ; Mode 7 center position X register (low)
	   sta $211F    ; Mode 7 center position X register (high)
	   sta $2120    ; Mode 7 center position Y register (low)
	   sta $2120    ; Mode 7 center position Y register (high)
	   sta $2121    ; Color number register ($0-ff)
	   sta $2123    ; BG1 & BG2 Window mask setting register
	   sta $2124    ; BG3 & BG4 Window mask setting register
	   sta $2125    ; OBJ & Color Window mask setting register
	   sta $2126    ; Window 1 left position register
	   sta $2127    ; Window 2 left position register
	   sta $2128    ; Window 3 left position register
	   sta $2129    ; Window 4 left position register
	   sta $212A    ; BG1, BG2, BG3, BG4 Window Logic register
	   sta $212B    ; OBJ, Color Window Logic Register (or,and,xor,xnor)
	   lda #$01
	   sta $212C    ; Main Screen designation (planes, sprites enable)
	   lda #$00
	   sta $212D    ; Sub Screen designation
	   lda #$00
	   sta $212E    ; Window mask for Main Screen
	   sta $212F    ; Window mask for Sub Screen
	   lda #$30
	   sta $2130    ; Color addition & screen addition init setting
	   lda #$00
	   sta $2131    ; Add/Sub sub designation for screen, sprite, color
	   lda #$E0
	   sta $2132    ; color data for addition/subtraction
	   lda #$00
	   sta $2133    ; Screen setting (interlace x,y/enable SFX data)
	   lda #$00
	   sta $4200    ; Enable V-blank, interrupt, Joypad register
	   lda #$FF
	   sta $4201    ; Programmable I/O port
	   lda #$00
	   sta $4202    ; Multiplicand A
	   sta $4203    ; Multiplier B
	   sta $4204    ; Multiplier C
	   sta $4205    ; Multiplicand C
	   sta $4206    ; Divisor B
	   sta $4207    ; Horizontal Count Timer
	   sta $4208    ; Horizontal Count Timer MSB (most significant bit)
	   sta $4209    ; Vertical Count Timer
	   sta $420A    ; Vertical Count Timer MSB
	   sta $420B    ; General DMA enable (bits 0-7)
	   sta $420C    ; Horizontal DMA (HDMA) enable (bits 0-7)
	   sta $420D    ; Access cycle designation (slow/fast rom)
;===========================================================================
;             	FINAL DE LA RUTINA DE INICIALIZACIN
;===========================================================================


;==========================================================================
; 	INICIALIZACIN DE LA VRAM PARA MOSTRAR GRFICOS 
;==========================================================================
;

	rep     #$30   		; X,Y fixed -> 16 bit mode
	sep     #$20   		; Accumulator ->  8 bit mode

	lda     #$10            ; El mapa de grficos estar en $1000 de VRAM
	sta     $2107           ; Plane BG1 Map location register

	lda     #$02            ; Usaremos el plano BG1; las tiles para este plan estarn en $2000 de VRAM
	sta     $210b           ; Slo hay que escribir el byte alto de la direccin en el registro del plano 0

;en el registro $2107 decimos a partir de qu posicin de memoria estarn los offsets de los tiles que hay que
;representar. En este caso, en la direccin $1000 de VRAM estar el offset a partir de la direccin $2000 de
;VRAM tambin donde se encuentra el tile que hay que poner en la esquina superior izquierda de la pantalla.
;Si queremos sacar una 'A' al principio de la segunda lnea de pantalla, en la direccin $1020 escribiremos $01
;si el tile de la 'A' se encuentra en la direccin $2008; cualquier tile se compone de 8 bytes, donde cada byte
;lleva informacin de los 8 pixels que forman esa fila del tile, que es 8x8


	lda     #$00            ; MODE 0 (plano BG1) value
	sta     $2105           ; Graphics mode register

	lda     #$01            ; Plane 0 value (bit one)
	sta     $212c           ; Plane enable register

	lda     #$00
	sta     $2121           ; Set color number to 0 (background)
	lda	#$00		
	sta	$2115		; configura el incremento del puntero de VRAM cada vez que se escribe en $2118

	lda     #$EF            ; blue color, lower 8 bits
	sta     $2122           ; enter color value #$46 to color num. (low)
	lda     #$01            ; blue color, higher 8 bits
	sta     $2122           ; enter color value #$69 to color num. (high)
	lda     #$ff            ; white color, lower 8 bits
	sta     $2122           ; write to next color number (01)
	sta     $2122           ; enter same value to color number (01)
	lda     #$40            ; color number (10)
	sta     $2122
	sta     $2122
	lda     #$80            ; color number (11)
	sta     $2122
	sta     $2122
	lda     #$01
	sta     $4200           ; ENABLE JOYPAD READ (bit one)

	lda	#INI_Y
	sta	POS_Y
	lda	#INI_X
	sta	POS_X

	lda	#$00
	sta	FLAG		; nos dice si estamos en una nueva lnea de texto o guardando la
	sta	FUENTE+2
aseguir
	lda	FLAG
	and	#$03
	cmp	#$00
	beq	presenta
	cmp	#$01
	beq	juego_car
	cmp	#$02
	bne	reset
	inc	a
	sta	FLAG
	stz	POS_X
	lda	#144
	sta	POS_Y
	ldx	#!DESPEDIDA
	bra	rutinas
juego_car
	inc	a
	sta	FLAG
	lda	#64
	sta	POS_X
	ldx	#!CHAR_SET
	bra	rutinas
presenta
	inc	a
	sta	FLAG
	ldx	#!PRESENTACION
rutinas
	stx	FUENTE

	jsr	limpia_RAM	; ponemos a $00 toda la zona de RAM a usar por las fuentes: "RAM_tiles"
	jsr	load_text	; descomprime el texto con MTE de la ROM y lo deja en "RAM_txt"
	jsr	load_font	; carga las tiles necesarias desde ROM segn el texto en "RAM_txt" y lo deja
				; en "RAM_tiles" tras calcular el VWF
	jsr	tiles2VRAM	; coge las tiles calculadas con VWF de "RAM_tiles" y las pone en VRAM en $2000
	jsr	text2VRAM	; coge los offsets de texto en y los mete en VRAM en $1000

	sep	#$20
	lda     #$0f            ; SCREEN ENABLED, FULL BRIGHTNESS (A = 0F = 00001111)
	sta     $2100           ;                                               bbbb 
	cli                     ; Clear interrupt bit
runar	lda   	$4210           ; check for Vertical blank
	and     #$80
	beq     runar	   	; no blank..  jump back!
joypad  lda     $4212           ; is joypad ready to be read?
	and     #$01
	bne     joypad          ; no? go back until it is!
	lda     $4219           ; read joypad high byte
	and     #$10            ; leave only "start" bit
	bne	aseguir        	; "start" pressed? go to RESET
	nop
	nop
	jmp     runar      	; if not then jump back to loop
reset   
	sep     #$30
	ldy     #$0f
lus1    ldx     #$06
	dey
	sty     $2100
wait    lda     $4210
	and     #$80
	beq     wait
	dex
	cpx     #$00
	bne     wait
	cpy     #$00
	bne     lus1
	rep     #$10
	ldx     #$0fff
dark    lda     $4210
	and     #$80
	beq     dark
	dex
	cpx     #$0000
	bne     dark


	sep     #$30
	lda     #$00
	pha                     ; push #$00 to stack
	plb                     ; pull #$00 from stack and make it the
                                ; the programming bank jump long to $008000
	jmp.l   start






;==========================================================================
;          	Mete el texto en RAM
;==========================================================================
; Esta rutina se encarga de leer el texto que hay que sacar por pantalla y
; pasarlo a RAM para que posteriormente, la rutina "text2VRAM" lo vuelque
; a VRAM para que se vea en pantalla; la cadena de texto a sacar estr en
; posicin $7E:A000 cuando se salga de esta rutina. Usaremos MTE.
; La rutina MTE consiste en 8 bits -> el MSB indica que ese byte representa
; ms de una letra; los 2 siguientes indican cuntas letras hay que traerse
; (00 -> traemos dos letras; 01 -> traemos 3 letras y as....) y los 5 ltimos 
; indican cul de las 32 entradas de MTE es la que se elige.


load_text
	rep	#$30		; pone los ndices X e Y en modo 16 bits
	lda 	#$0000		; limpia el acumulador
	sep	#$20		; pone el acumulador en modo 8 bits

	phb			; guarda en pila el banco de datos
	lda	#$7E
	pha			; guarda en pila el banco de RAM
	plb			; para que sea el nuevo banco de datos

	ldx	#$0000		; X ser el offset a los bytes de texto comprimido
	ldy	#$0000		; Y ser el offset a los bytes de texto descomprimido en RAM
nxt_byte
	phy
	txy
	lda	[FUENTE],y	; me cojo un byte del buffer de entrada
	inx			; apuntamos al siguiente byte de entrada
	ply
	cmp	#<FINAL_TEXTO	; comparamos con el byte de final de texto
	beq	fin_text	; el byte $00 indica el final de la cadena de texto comprimido
	cmp	#$80		; si es <$80 es que ese byte es una letra y no MTE
	bcc	NO_MTE		; si en menor, se salta para tratar el byte como una letra normal

	PHX			; guardamos X para luego traernos otro byte porque necesitamos este registro
	PHA			; guardamos en pila el byte para usarlo luego
	AND	#$60		; slo dejamos los bits que indican cuantas letras hay que coger
	LSR	A
	LSR	A
	LSR	A
	LSR	A
	LSR	A		; ponemos esos bits en la parte baja para usarlos como indice
	INC	A		; sumamos uno + uno puesto que 00 indicara dos letras como mnimo
	INC	A
	STA	!count		; lo ponemos en la variable de RAM que indica el nmero de bytes a leer
	PLA			; necesitamos el byte original para saber el offset en la tabla MTE
	AND	#$1F		; nos quedamos con los 5 bits LSB que indican el offset
	ASL	A		; multiplicamos el offset por dos puesto que est referido a 16 bits (2 letras)
	TAX			; ahora X dice el offset de la tabla MTE

nxt_MTE	lda	MTE,X		; cargamos el primer byte del MTE
	sta	!RAM_txt,Y	; lo guardamos en la posicin correspondiente del array de RAM
	iny			; apuntamos a la siguiente posicin de RAM para guardar la salida
	inx			; apuntamos al siguiente byte del DTE
	lda	!count		; cogemos la variable contador de RAM
	dec	A		; decrementamos el contador de bytes de MTE que hay que leer
	sta	!count		; volvemos a guardarlo en RAM
	cmp	#$0000
	bne	nxt_MTE		; si no se ha llegado a cero, hay ms bytes que leer del diccionario MTE
	plx			; restauramos el ndice de la cadena de entrada para el bucle principal
	bra	nxt_byte	; si se ha llegado a cero, no hay que coger ms bytes de MTE; se vuelve al bucle
NO_MTE
	sta	!RAM_txt,Y	; simplemente guardamos el byte ledo
	iny			; apuntamos a la siguiente posicin vaca de RAM para escribir
	bra	nxt_byte	; seguimos cogiendo bytes de la entrada
fin_text
	sta	!RAM_txt,Y	; guarda el byte de final de cadena
	plb
	rts




;==========================================================================
;          Carga la fuente de las letras necesarias en "RAM_tiles"
;==========================================================================
; como la fuente es 8x12 variable de anchura, lo que tenemos son 2 tiles 8x8 "uno encima del otro", por lo
; que apra representar adecuadamente la fuente, hemos de guardar un tile en la posicin $2000 de VRAM por 
; ejemplo y su parte inferior en $2020; cuando la letra sea de anchura inferior, lo deberemos indicar en una
; tabla para que al guardar en VRAM los dos tiles de la letra siguiente, superpongamos (con una OR) la que
; queda a la derecha sobre parte de la inmediatamente a su izquierda (que es la ms corta)
; Hay que recordar que la fuente es 8x14, es decir, 8 pixels de ancho como mximo (es VWF as que el ancho
; variar segn la letra) y 14 de alto, lo que quiere decir que se guarda en la ROM el tile superior de
; 8x8 al completo y el tile inferior se guarda slo 8x6, siendo las 2 lneas inferiores del tile todo $0
; EN ESTE EJEMPLO, PARA MAYOR SIMPLICIDAD, GUARDAREMOS LAS 16 FILAS DE LA FUENTE EN ROM.
; ya que estn vacas. Las 4 lneas que s se guardan en ROM Se usan para las comas, la g, la p, la y etc.
; Es en esta parte donde se elige qu byte hexadecimal representar a cada letra, ya que ese ser el offset
; que tendr que tener dicha letra respecto de la base, que nosotros la hemos fijado en $2000; cogeremos $20
; como la letra 'A' (ver tabla del Chrono Trigger)

load_font
	rep     #$30   		; X,Y,A fixed -> 16 bit mode
	sep	#$20		; acumulador de 8 bits

	phb			; guarda en pila el banco de datos
	lda	#$7E
	pha			; guarda en pila el banco de RAM
	plb

	lda	#$00		; ponemos a cero el contador de tiles
	sta	!count		; contador de bytes ledos; slo se usa para saber si se han ledo todos los
				; bytes correspondientes a un tile

	ldx     #$0000		; offset a las fuentes en ROM
	stx	!NUM_TILES	; este es el contador de tiles definitivas que se escribirn en la pantalla
	stx	!cnt_tile	; inicializamos el contador: contiene el puntero al buffer de entrada de texto
	ldy     #$0000		; offset de salida donde se guardarn byte a byte las fuentes en RAM

; en cada pasada de este bucle, Y ha de permanecer inalterado, por lo que si se quiere usar este registro
; para algo, se ha de meter en pila y sacar posteriormente; el valor de X cada vez que se entra aqu no
; importa.
fin_linea
	stz	!PATRON		; si hay salto de lnea, ya no se desplazan las tiles y se empieza desde cero
	stz	!NEW_PATRON	; por eso reseteamos los patrones
princ	
	lda	!NEW_PATRON
	sta	!PATRON

	ldx	!cnt_tile	; cargamos puntero al buffer de texto de entrada descomprimido
	lda	!RAM_txt,x	; cogemos un byte del texto descomprimido
	inx			; apuntamos al siguiente carcter
	stx	!cnt_tile

	cmp	#<FINAL_LINEA	; comprobamos si es el final de lnea
	beq	fin_linea	; si lo es, simplemente traemos otra letra
	cmp	#<FINAL_TEXTO	; comprobamos si es el final del texto
	beq	fin_VWF		; si es el final del texto, salimos de la rutina

	rep	#$20		; acumulador de 16 bits
	and	#$00FF		; limpiamos el acumulador para las operaciones
	sec			; preparamos la resta
	sbc	#OFFSET_A	; le quitamos el offset de la primera letra ('A') para saber el offset en ROM
	pha			; guardamos el valor en pila puesto que luego lo usare para calcular el offset

; hay que consultar la tabla para saber si la letra que nos vamos a traer tiene anchura especial				
	ldx	#$0000		; limpiamos X
	lsr	A		; dividimos entre 2 el desplazamiento de la letra respecto a la 'A'
				; ya que cada byte contiene informacin de dos letras
	php			; guardamos la palabra de estado en pila porque el carry lleva el LSB
	tax			; tenemos el byte de la tabla VWF que hay que leer
	sep	#$20		; acumulador de 8 bits
	lda	TABLA_VWF,X	; cargamos el valor de la tabla
	plp			; retomamos la palabra de estado para ver que parte del byte tomar (A = 16 bits)
	sep	#$20		; acumulador de 8 bits
	bcc	par		; si el LSB era cero (que est en el carry),hemos de tomar los 4 bits superiores
	and	#$0F		; si era uno, tomamos los 4 bits inferiores
	bra	sigue
par	and	#$F0		; tomamos los 4 bits superiores
	lsr	A		
	lsr	A
	lsr 	A
	lsr	A		; los ponemos en la parte baja los 4 bits

; en este punto ya tenemos la informacin de anchura de la letra que nos tenemos que traer
; ahora hemos de comprobar si la tile es menor, mayor de lo normal o igual; al anchura de la letra
; la guardaremos en la correspondiente variable; por defecto ser $08 (8 pxeles)
sigue	cmp	#$00		; si es $00, la letra es normal
	beq	igual		; hacemos el procedimiento de siempre
	cmp	#$08		; si es ACC < $08, la letra es ms pequea; si ACC >= $08, es ms grande
	bcs	mayor		; saltamos si es mayor o igual que $08
	and	#$07		; si es menor, arreglamos las letras que siguen, obteniendo el desplazamiento
	pha			; guardamos este valor en pila para hacer la resta
	lda	#$08		; a los 8 pxeles de anchura estndar, le restamos el desplazamiento
	sec			; puesto que ste indica los pxeles vacos del tile
	sbc	$01,S		; le resto lo de la pila, que es el desplazamiento
	sta	!ANCHO_TILE	; actualizamos la variable
	pla			; restauramos el valor de desplazamiento para operar con l	
	clc			; preparamos la suma
	adc	!PATRON		; le sumamos el desplazamiento (porque ste es hacia izda) acumulado hasta ahora
	cmp	#$08		; miramos si hemos superado el lmite de pxeles de desplazamiento que es 8
	bcc	no_resta	; si es ms pequeo, cogemos la parte dcha de la letra actual
	and	#$07		; le restamos 8 para que est entre 0 y 8 (ponemos el 4 bit LSB a cero)
no_resta	
	sta	!NEW_PATRON	; lo guardamos en memoria para la siguiente tile, no para esta
	bra	ready		; guardamos esta letra normalmente aunque sea ms pequea ya que sto slo
				; afecta a las siguientes, que se corrern hacia la izquierda
fin_VWF	
	brl	salida

; si la tile es mayor de lo normal, el desplazamiento nos indicar cuntos pxeles es ms ancha. Esto es
; equivalente a pensar que el tile que vamos a guardar es el "extra" ms grande y por tanto, el hueco que
; tendr a la dcha este tile extra ser 8 (anchura total del tile) menos lo que ocupe extra, que viene
; indicado por el desplazamiento; por ejemplo, si hemos escrito la "i" que deja un hueco de 4 pxeles
; a su derecha (desplazamiento acumulado = 4) y ahora escribimos la "M", que ocupa un dos pxeles de ms 
; (10 pxeles en total; desplazamiento de la "M" = 2); tendremos que correr la primera tile de la "M" 4 
; pxeles a la izda para encajarla ; en el hueco sobrante de "i", con lo que el desplazamiento acumulado 
; seguir siendo 4; ahora escribimos la parte extra de "M" que ocupa 2 pxeles, que sern los ms a la 
; izda de esos 4 que sobraban de la "M"; por tanto, el desplazamiento acumulado ahora ser de 2 a la dcha 
; de la "M", que en frmula es: 	 PATRON ( desp_acumulado) + 8 - desp_"M" = 10
; como el desplazamiento se ha de normalizar respecto de 8 que es la anchura del tile, esto d como
; resultado final un desplazamiento acumulado de 10 - 8 = 2 que es el que deba de dar. 
mayor
	sta	!ANCHO_TILE	; actualizamos la variable ya que si la letra es mayor de un tile, el valor
				; ledo de la tabla es directamente su tamao en pxeles
	and	#$07		; si es mayor, arreglamos las letras que siguen obteniendo el desplazamiento
	pha			; tenemos que restar desde el acumulador
	lda	#$08		; la resta que hacemos es (ACC - STACK); por tanto, restamos 8-d
	sec			; preparamos la resta
	sbc	$01,S		; restamos al desplazamiento (porque ste es hacia dcha) acumulado el patrn
				; esta resta NUNCA puede ser negativa, puesto que el desplazamiento mximo es 8
	clc			; preparamos la suma
	adc	!PATRON		; le sumamos el patrn acumulado
;	cmp	#$08		; miramos si hemos superado el lmite de pxeles de desplazamiento que es 8
;	bcc	no_resta_bis	; si es ms pequeo, el desplazamiento ya es vlido
;	and	#$07		; le restamos 8 para que est entre 0 y 8 (ponemos el 4 bit LSB a cero)
;no_resta_bis
	sta	!NEW_PATRON	; lo guardamos en memoria para la siguiente tile

	pla			; sacamos el operando de la resta
	lda	!PATRON		; hay que actualizar lo que hay que hacer con este tile
	ora	#$80		; ponemos el MSB del byte a '1' para indicar que hay que leer su extensin
	sta	!PATRON		; cuando analicemos "PATRON" sabremos cunto hay que desplazar y que hay
				; que leer la tile y la extensin de ella
	bra	ready

; En este punto ya sabemos lo que tenemos que hacer con el tile que va a leerse (por la informacin en
; "PATRON") y el efecto que l producir en los siguientes tiles (est en "NEW_PATRON"); ahora hemos de
; hacer un salto a una rutina que se traiga tiles y los desplace, tanto si la letra que nos hemos de traer
; es ms ancha como si es ms estrecha, ya que en ambos casos hay que desplazar y slo en el caso de que
; sea ms ancha, entonces tendremos que traernos el tile extra; o simplemente hemos de saltar a la rutina 
; normal que no hace nada especial con el tile ledo

igual
	lda	#$08		; si la letra es de tamao normal, ponemos 8 pxeles en el acumulador
	sta	!ANCHO_TILE	; y lo guardamos en la correspondiente variable
ready
	rep	#$20		; acumulador de 16 bits de nuevo
	pla			; sacamos el byte ledo ya restado del offset de 'A'
	asl	A
	asl	A
	asl	A
	asl	A
	asl	A		; multiplicamos por 32, puesto que cada letra son 32 bytes
	pha			; el offset a la tiles en ROM se mete en la pila (2 bytes)
	sep	#$20		; acumulador de 8 bits de nuevo

; Al llegar a este punto ya tenemos la letra en RAM ocupando 32 bytes; los primeros 16 bytes son la parte
; superior de la letra y a continuacin, seguidos vienen los 16 bytes de la parte inferior; as se van
; guardando sucesivamente una a una todas las letras de la frase que queremos sacar por pantalla.
; Es en este punto adems donde hemos de comprobar si la letra que hemos cogido es de tamao normal, mayor
; o menor; apra ello usaremos una tabla de bytes, donde cada 4 bits corresponden a una letra de la fuente;
; es decir, el primer byte tendr en los 4 bits MSB la informaicn de cmo es la letra 'A', que es la primera
; de la fuente; esta info es:	
;	GDDD		bit G: 	'0' es que la letra es ms pequea de lo normal; '1', indica que es ms grande
;			bits DDD: indica cuntos pixels tiene de desplazamiento
;
; Por ejemplo, la letra 'i' ocupa los 4 pxeles ms a la izda del tile, ms uno que dejamos de espacio con la
; siguiente letra, quiere decir que los 3 pxeles ms a la dcha estn libres y debern albergar a 3 pixeles
; de la letra que vaya a continuacin; el cdigo para la tabla correspondiente a 'i' ser %0011.
; Si ponemos %0000 es que la letra es de tamao normal.
; al entrar aqu slo importa lo que hay en Y, que ha de ser el puntero al buffer de tiles de salida y lo que
; hay en la ltima posicin de la pila, que ha de ser en offset a la tile guardada en ROM

desp_tl
	plx			; recogemos el puntero a la tile en ROM (16 bits)
	phy			; guardamos el puntero al buffer de salida de tiles
	ldy	#$0000		; reseteamos el puntero a la tile temporal

; Rutina para mover 32 bytes de cada tile desde la direccin donde empieza la fuente en ROM ("FUENTE_VWF")
; desde el offset indicado por X hasta la direccin indicada en al variable 'DESTINO' empezando en el offset
; indicado en el ndice Y; el acumulador ha de ser de 8 bits y los ndices de 16;
	stz	!count		; el contador se ha de poner siempre inicialmente a cero
bucle
	lda  	FUENTE_VWF,x	; lee cada byte que se corresponde con cada lnea del tile 8x8
	sta     !TEMP_TILE,y	; guardamos en RAM la parte correspondiente al bitplane 2 (ir a $2119)
	inx			; apuntamos al siguiente byte (contador de lneas)
	iny			; apuntamos al siguiente espacion vaco del buffer de tiles de salida
	lda	!count		; contador de palabras de 16 bits ledas (lneas del tile)
	inc	A		; incrementamos
	sta	!count		; guardamos en memoria de nuevo
	cmp	#$20		; comprobamos si hemos cogido las 16 palabras de 16 bits del tile completo
	bne	bucle		; si aun no, seguimos cogiendo lneas del tile superior
	
	inc	!NUM_TILES	; como hemos guardado las dos tiles de una letra, aumentamos el contador

; el siguiente trozo de cdigo se encargar de leer el tile que tenemos que desplazar y desplazar uno a uno
; los 32 bytes que lo componen

	ldx	#$0000		; este ser el offset para leer del tile que est en la posicin temporal
	rep	#$20		; acumulador de 16 bits
	stz	!count		; reseteamos el contador de lneas ledas
desplaza_tl
	rep	#$20
	lda	!PATRON		; cargamos el byte del patrn
	and	#$0007		; nos quedamos con los tres bits inferiores que dicen el desplazamiento
	tay			; lo ponemos en Y
	
	lda	!TEMP_tile,X	; leo el primer byte del temporal (aunque me traigo 16 bits)
	AND	#$00FF		; limpiamos parte alta porque solo quiero el bye bajo que es el vlido
desx	
	cpy	#$0000		; no hemos de desplazar si el patrn indica $00
	beq	saltar		; saldimos del bucle cuando el contador de desplazamientos llegue a cero
	asl	a		; desplazamos un pixel a la izda
	dey			; decrementamos el contador de desplazamientos
	bra	desx		; se sigue el bucle siempre
saltar
	pha			; guardamos los 16 bits ya desplazados
	txa			; leemos el puntero
	asl	a		; la direccin de X se multiplica por dos (porquese guardan 16 bits)
	tax			; guardamos el puntero
	pla			; recuperamos los 16 bits desplazados
	sta	!DESP_tile,X	; se guardan 16 bits, que son dos tiles
	txa			; hay que dividir por 2 la direccin de salida (se leen bytes)
	lsr	a		; puntero dividido por dos
	inc	a		; aputnamos a la siguiente tile
	tax			; lo dejamos de nuevo en X
	lda	!count		; contador de palabras de 16 bits ledas (lneas del tile)
	inc	A		; incrementamos
	sta	!count		; guardamos en memoria de nuevo
	cmp	#$0020		; comprobamos si hemos cogido los 32 bytes del tile completo
	bne	desplaza_tl	; si aun no, seguimos cogiendo lneas del tile superior
	
; en este punto tenemos en "DESP_tile" las dos partes del tile (superior e inferior) guardadas en posiciones
; impares (DESP_tile + 1, DESP_tile + 3, DESP_tile + 5,...) y que ser la parte que tenemos que "insertar" en
; el tile anterior que era de tamao menor del normal; en posiciones pares est la otra parte del tile
; que guardaremos a continuacin.

	stz 	!count
	pla			; sacamos el puntero de salida al acumulador para operar con l
	sec			; preparamos la resta
	sbc	#$20		; lo ponemos apuntando al principio del tile que era de anchura distinta
	tay			; lo ponemos en el ndice
	ldx	#$0001		; ponemos a uno el ndice para leer las tiles desplazadas en posiciones impares
	sep	#$20		; acumulador de 8 bits

insert_tl
	lda	!RAM_tiles,Y	; cargamos el primer bytes del tile que es ms estrecho
	ora	!DESP_tile,X	; le hacemos OR con el tile desplazado para meter los pixeles correspondientes
	inx			; aumentamos en 2 el puntero X para saltarnos la parte derecha del tile 
	inx			; desplazado y apuntar al byte adecuado (direcciones impares)
	sta	!RAM_tiles,Y	; sustituimos el anterior por el nuevo con parte de la siguietne letra ya insertada
	iny			; apuntamos al siguiente byte de la tile
	lda	!count		; contador de palabras de 16 bits ledas (lneas del tile)
	inc	A		; incrementamos
	sta	!count		; guardamos en memoria de nuevo
	cmp	#$20		; comprobamos si hemos cogido los 32 bytes del tile completo
	bne	insert_tl	; si aun no, seguimos cogiendo lneas del tile

; al salir de este bucle, ya tenemos actualizada la letra ms estrecha con la porcin de la siguiente letra
; que haba que introducir; ahora hemos de guardar a continuacin de este tile, la parte de la letra que hay
; a la dcha de la actual; si el patrn es mltiplo de 8, quiere decir que la parte esplazada a izda ha
; encajado perfectamente con la anterior letra y no hay que poner un tile (que estar vaco) a la dcha de ste.
; esto lo sabemos mirando si el patrn para la siguiente letra es $08
; para saber si nos hemos de traer la parte derecha de un tile o no vemos si el desplazamiento que le acabamos 
; de dar ("PATRON") es mayor que la anchura de esta letra; si el desplazamiento es mayor o igual, no se
; dibuja la parte derecha

cmp_dcha
	lda	!PATRON		; cargamos el patrn, que es lo que hemos desplazado la letra
	cmp	#$80		; si el MSB est activado s hay que traer la parte derecha SIEMPRE
	bcs	tl_dcha		; saltamos para traernosla
	and	#$07		; el desplazamiento est en los tres bits inferiores
	cmp	!ANCHO_TILE	; comparamos con el tamao que tiene la letra
	bcc	tl_dcha		; si el tamao de la letra es mayor que el desplazamiento que hemos hecho,
				; hemos de coger la parte derecha
	brl	princ		; si el tamao es menor no, porque al ser menor se habr metido toda la letra
				; en la anterior
tl_dcha
	stz	!count		; reseteamos el contador de lneas ledas
	ldx	#$0000		; ponemos X para acceder a las posiciones pares del tile desplazado
sig_tl
	lda	!DESP_tile,X	; cargamos el primer byte de la parte derecha del tile que acabamos de desplazar
	inx			; aumentamos en 2 el puntero X para saltarnos la parte izda del tile 
	inx			; desplazado y apuntar al byte adecuado	(direcciones pares)
	sta	!RAM_tiles,Y	; guardamos a continuacin
	iny			; apuntamos al siguiente byte de la tile
	lda	!count		; contador de palabras de 16 bits ledas (lneas del tile)
	inc	A		; incrementamos
	sta	!count		; guardamos en memoria de nuevo
	cmp	#$20		; comprobamos si hemos cogido los 32 bytes del tile completo
	bne	sig_tl		; si aun no, seguimos cogiendo lneas del tile
	inc	!NUM_TILES	; como hemos guardado las dos tiles de una nueva letra, aumentamos el contador

; ahora ya est todo hecho, pero hay que comprobar que no habra que coger el tile extra de una letra
; ms ancha de lo normal; para ello testeamos el MSB del PATRON
	lda	!PATRON
	and	#$80		; comprobamos el MSB
	bne	new_tl		; si est activo el bit, hay que traerse la parte extra del tile
	brl	princ		; si no lo est, volvemos a por otro byte ms

; Si entramos en este trozo de cdigo es porque se ha de escribir alguna de las letras grandes, que son:
; K,M,W,m,w, y los smbolos 'nota', '%' e 'inf'; todos ellos tiene un tile extra que traer para poner 
; a continacin del principal, por lo que hay que calcula de alguna manera el offset a ese tile extra.
; una vez calculado este offset, lo pasamos como parmetro a travs de la pila al cdigo "desp_tl" y
; la tratamos como una tile totalmente nueva que ser ms estrecha de lo normal y cuyo patrn ser el
; mismo que el de su parte izda; si al "PATRON" le ponemos el MSB a '0', sertratada como una tile normal
; y cuando la haya desplazado y guardado, se saldr a por una nueva letra normalmente.

new_tl
	inc	!NUM_TILES	; como hemos guardado las dos tiles de una nueva letra, aumentamos el contador
	rep	#$20
	lda	#$0000		; limpiamos el acumulador
	sep	#$20
	ldx	!cnt_tile	; cargamos puntero al buffer de texto de entrada descomprimido
	dex			; apuntamos de nuevo al carcter que acabamos de traernos
	lda	!RAM_txt,x	; cogemos el byte del texto descomprimido que estamos tratando ahora	
	sec			; preparamos la resta
	sbc	#OFFSET_A	; le restamos el offset de la primera letra
	pha			; lo metemos en el acumulador
	and	#$0F		; los cuatro bits inferiores indican el offset en la lnea
	asl	a		; multiplicado por 2 apunta al vector en cuestin
	tax			; el resultado lo guardamos temporalmente en X

; el cdigo a continuacin se ha de variar si cambia la forma de obtener el offset a la table de tiles extras
; (la que contiene los offsets a los tiles extras) ; en mi caso, el offset se obtiene usando el byte
; normalizado, es decir, una vez restado de l el offset de la letra 'A'; con este valor, los tres bits
; superiores indican la lnea de la tabla extra a la que accedemos (hay que multiplicar por 32 para obtener
; el offset real); los cuatro bits inferiores indican el offset dentro de esa lnea al que accedemos, tras
; haberlos multiplicado por 2 puesto que el vector al tile extra es de 16 bits;

	pla			; recuperamos el valor guardado
	and	#$E0		; slo queremos los 3 bits superiores
	pha			; escritura inutil que solo sirve para luego sacar los 16 bits a X
	pha			; se va al acumulador para sumarlo con el offset dentro de la lnea
	txa			; recuperamos ese offest que estaba en X
	clc
	adc	$01,S		; sumamos el offset de la lnea
	plx			; sacamos los 16 bits del operando de la suma que ya no se necesita en pila
adelante
	rep	#$20		; ACUMULADOR DE 16 BITS
	AND	#$00FF		; cogemos el byte inferior
	tax			; ser el offset a la tabla donde dice el offset del tile a traer
	lda	TABLA_EXTRA,X	; cogemos los 16 bits del vector
	pha			; el vector se ha de pasar como parmetro en la pila

	sep	#$20		; acumulador de 8 bits de nuevo
	lda	!ANCHO_TILE	; el ancho de la tile extra que vamos a traer es el total de la actual menos 8
	sec			; preparamos la resta
	sbc	#$08		; restamos 8
	sta	!ANCHO_TILE	; actualizamos el valor de la anchura
	lda	!PATRON		; cargamos el patrn de nuevo
	and	#$7F		; ponemos el MSB a cero -> no hay que traer ninguna tile ms para esta letra
	sta	!PATRON		; lo guardamos
	brl	desp_tl

salida	
	plb			; restauramos el banco de datos anterior a la llamada a la subrutina
	rts


;==========================================================================
;          	Mete en VRAM $1000 el texto que hay en RAM 
;==========================================================================
; Al usar una VWF, hemos de tener en cuenta varios factores; esta rutina ahora no se encarga simplemente
; de coger el texto en RAM y pasarlo a VRAM, sino que ahora ha de tener en cuenta que los tiles superiores
; de cada letra y los inferiores estn uno a continuacin del otro, con lo que se tendr que cuidar de poner
; el tile inferior con un offset de $20 (32 posiciones puesto que una fila de pantalla tiene 32 tiles 8x8)
; respecto a su parte inferior para que salga adecuadamente en pantalla; para ello, con el valor hexadecimal
; que representa a cada letra, se le quita el offset de base (que en este caso es "offset_A = $20"), se
; multiplica por dos puesto que cada tile son dos posiciones, y se le suma a "offset_A" de nuevo; por ejemplo,
; la letra 'E' es el byte $24, pero los dos tiles correspondientes a esa letra no estn en el offset de VRAM
; $2000 + ($24 x 8) como cabra esperar si cada letra fuera un tile slo, no dos; s sabemos que la 'E' est
; a 4 letras de distancia de la 'A' siendo el offset de 'A' $2000 + ($20 x 8) como vimos en la rutina anterior
; por tanto, el offset de 'E' es $2000 + ( ((($24 - $20) x 2) + $20) x 8 ) que en el mapa que hay en $1000
; que es donde se guardan los offset, habra que almacenar el valor ($24 - $20) x 2 + $20

; Esta es la rutina encargada de decir qu aparecera en cada una de las celdillas en las que se divide la
; pantalla entera; tenemos 32 x 32 celdas en total (aunque es configurable) de 8 x 8 pixeles cada una; el
; problema aqu es que para bajar de lnea, como la VRAM es lineal, tenemos que aumentar el puntero hasta

; llegar al final de lnea; es decir, que si estamos en la celdilla 31 de la primera fila, al movernos a
; la 32, en realidad lo que estamos haciendo es bajar a la celdilla 1 de la segunda fila; por ello, la
; posicin de Y en la segunda fila, por ejemplo, ser la celdilla 32, que es ( (fila) - 1 ) x 32; hay que
; recordar que la primera celdilla es la nmero 0, no la 1 ;)
text2VRAM
	rep     #$30   		; X,Y,A fixed -> 16 bit mode
	sep	#$20		; acumulador de 8 bits

	phb			; guarda en pila el banco de datos
	lda	#$00
	pha			; guarda en pila el banco de RAM
	plb

	ldy	#$0000

	lda	#$80		; se incrementa el puntero a la VRAM que est en $2116 cada vez que se
	sta	$2115		; se escriba en el registro $2119

	ldx	#$1000
	stx	$2116

	lda	#$FF
llenado	sta	$2118		; llenamos la pantalla con vaco
	stz	$2119
	iny
	cpy	#$0400
	bne	llenado

	ldy	#$0000		; inicializamos	 cero todos los registros
	ldx	#$0000
	lda	#$00
	pha			; lo guardamos para tener el byte alto de la suma a $00

	lda	POS_X		; cargamos la posicin de X que queremos (en pixeles); no superior a 256
	lsr	A
	lsr	A
	lsr	A		; como cada celdilla es de 8 bits de ancho, dividimos entre 8
	pha			; guardamos en el acumulador porque luego lo necesitaremos (1 byte)

	lda	POS_Y		; ahora cargamos la posicin de Y que queremos, igual que antes
	rep	#$20		; acumulador de 16 bits
	and	#$00FF		; limpiamos el byte MSB del acumulador
	lsr	A
	lsr	A
	lsr	A		; como cada celdilla es de 8 bits de alto, dividimos entre 8
	dec 	A		; ajustamos la posicin horizontal
	asl	a	
	asl	a
	asl	a
	asl	a
	asl	a		; multiplicamos por 32 para obtener la celdilla primera de esa fila
	clc			; preparamos la suma
	adc	$01,S		; le sumamos lo que hay en la pila, que es el desplazamiento dentro de esa fila
	clc
	adc	#$1000		; le sumamos el inicio del mapa de pantalla en VRAM
	sta	VRAM_POS	; guardamos en RAM el valor del puntero a la esquina superior izda del texto
	sta	$2116		; establecemos el puntero a VRAM en esa posicin
	pla			; lo de la pila slo era para sumarlo con el valor del acumulador (2 bytes)

; con este cdigo anterior ya tenemos calculada la direccin de VRAM inicial donde hemos de escribir el texto
; ahora hemos de empezar a escribir los offsets respecto a la direccin $2000 donde estn las tiles a sacar.
; El problema de esto es que una letra no se corresponde con un tile exactamente debido a la anchura variable;
; Por tanto, no podemos saber a priori cuntas tiels hay que escribir en pantalla; para saberlo, hemos de ir
; leyendo las anchuras de cada una de las letras que componene una lnea e ir sumndolas; as sabremos el nmero
; de pxeles que tiene uan lnea; dividiendo entre 8 tendremos directamente el nmero exacto de tiles a meter
; en cada lnea

	sep	#$20		; acumulador de 8 bits
	ldx	#$0000
	ldy	#$0000
	lda	#$00
	sta	VALOR_INI	; valor inicial del tile superior de una lnea
	sta	OFFSET_INI	; valor de X al comienzo de cada lnea
	sta	ANCHO_LINEA
	sta	ANCHO_LINEA+1

; vamos a ir leyendo del buffer de texto para ir calculando la anchura de cada lnea

calcula
	phx			; guardamos X porque lo necesitamos para hacer indexar con direcciones largas
	tyx			; pasamos el valor de Y (offset al buffer de entrada) al registro X
	lda	RAM_txt,x	; leemos el primer carcter del buffer original
	iny			; apuntamos a la siguiente letra
	plx			; recuperamos el valor de X
	pha			; guardamos el valor ledo (slo se necesita si se salta a "escribe_lin")
	cmp	#<FINAL_LINEA	; comprobamos si hay que cambiar de lnea
	beq	escribe_lin	; si es el salto de lnea, saltamos para poner el puntero en su lugar
	cmp	#<FINAL_TEXTO
	beq	escribe_lin
	pla			; como no se ha hecho el salto, ya no nos hace falta el valor	
	sec			; preparamos la resta
	sbc	#OFFSET_A	; restamos el offset respecto a 'A'
	phx
	ldx	#$0000		; limpiamos X
	lsr	A		; dividimos entre 2 el desplazamiento de la letra respecto a la 'A'
				; ya que cada byte contiene informacin de dos letras
	php			; guardamos la palabra de estado en pila porque el carry lleva el LSB
	tax			; tenemos el byte de la tabla VWF que hay que leer
	sep	#$20		; acumulador de 8 bits
	lda	TABLA_VWF,X	; cargamos el valor de la tabla
	plp			; retomamos la palabra de estado para ver que parte del byte tomar (A = 16 bits)
	sep	#$20		; acumulador de 8 bits
	bcc	par_0		; si el LSB era cero (que est en el carry),hemos de tomar los 4 bits superiores
	and	#$0F		; si era uno, tomamos los 4 bits inferiores
	bra	sigue_0
par_0	and	#$F0		; tomamos los 4 bits superiores
	lsr	A		
	lsr	A
	lsr 	A
	lsr	A		; los ponemos en la parte baja los 4 bits
sigue_0
	cmp	#$08		; si el desplazamiento es menor que 8, la anchura es 8 - desplazamiento
	bcs	no_restes	; si es mayor o igual que 8, ese valor es directamente la anchura de la letra
	pha			; esto se escibe en pila porque luego se sacabn 16 bits
	pha			; guardamos el desplazamiento en pila para restar
	lda	#$08		; metemos el minuendo en el acumulador
	sec			; preparamos la resta
	sbc	$01,S		; restamos lo que hay en la pila, que es el desplazamiento
	plx			; sacamos el operando de la resta con 16 bits
no_restes
	rep	#$20		; acumulador de 16 bits
	AND	#$00FF		; limpiamos byte alto
	clc			; preparamos la suma
	adc	ANCHO_LINEA	; le sumamos a la anchura de esta letra el total acumulado
	sta	ANCHO_LINEA	; guardamos el valor en RAM

	sep	#$20		; ACUMULADOR DE 8 BITS
	plx			; recuperamos el valor de X
	bra	calcula

; al entrar es este trozo de cdigo, ya tenemos en memoria el tamao en pxeles que ocupa el texto de la lnea
; que se ha de escribir. Si dividimos entre 8 ya tenemos el nmero de tiles que se dibujarn
escribe_lin
	jsr	WRITE_TILES
	rep	#$20		; acumulador de 16 bits
	lda	VRAM_POS	; actualizamos el puntero para que escriba en la siguiente lnea de pantalla
	clc			; preparamos la suma
	adc	#$0020		; bajamos dos lneas desde donde estbamos
	sta	$2116		; guardamos en el registro que contiene el puntero a VRAM
	sta	VRAM_POS	; actualizamos la variable que contiene el puntero en RAM
	lda 	#$0000		; limpiamos el acumulador
	sep	#$20		; acumulador de 8 bits

	lda	VALOR_INI
	inc	a		; le aadimos uno al valor inicial de las tiles superiores
	sta	VALOR_INI	; "VALOR_INI" contiene el valor del primer byte a representar en esa lnea
	jsr	WRITE_TILES
	dec	a		; ya se han escrito los tiles inferiores; apuntamos al superior de la siguiente lnea
	sta	VALOR_INI	; la nueva lnea empieza con este valor en los tiles superiores
	rep	#$20		; ACUMULADOR DE 16 BITS
	lda	VRAM_POS	; actualizamos el puntero para que escriba en la siguiente lnea de pantalla
	clc			; preparamos la suma
	adc	#$0020		; bajamos dos lneas desde donde estbamos
	sta	$2116		; guardamos en el registro que contiene el puntero a VRAM
	sta	VRAM_POS	; actualizamos la variable que contiene el puntero en RAM
	lda 	#$0000		; limpiamos el acumulador
	sta	ANCHO_LINEA	; reseteamos el contador de pxeles para la siguiente lnea
	sep	#$20		; acumulador de 8 bits
	pla			; sacamos el byte ledo de la pila
	cmp	#<FINAL_TEXTO	; si era el carcer de fin de texto
	beq	final_VRAM	; se sale de al rutina
	brl	calcula

final_VRAM
	plb
	rts
	
; la rutina a continuacin se encarga de escribir todos los tiles de una lnea de pantalla empezando por el
; valor indicado en "VALOR_INI", a partir de la direccin actual de VRAM y el nmero de tiles
; indicado en "ANCHO_LINEA" dividido por 8.
WRITE_TILES
	php			; guardamos la palabra de estado
	phy			; guardamos en pila el valor que haya en Y porque necesitaoms ese registro
	rep	#$20		; acumulador de 16 bits
	lda	#$0000
	lda	ANCHO_LINEA	; cargamos el valor en pxeles
	lsr	a
	lsr	a
	lsr	a		; divido entre 8 pxeles que tiene cada tile para obtener el nmero de tiles
	pha			; guardamos este valor
	lda	ANCHO_LINEA	; ahora comprobamos el redondeo: 89 pxeles son 11 tiles, por ejemplo
	and	#$0007		; los tres ltimos bits son los que marcan el redondeo
	cmp	#$0000		; se compara con cero; cualquier valor distinto de cero es que hay una tile ms
	beq	inicia_tl	; si no los pxeles eran exactos, se sigue adelante
	lda	#$0001		; le sumamos una tile ms
inicia_tl
	clc			; se prepara la suma
	adc	$01,S		; se aade el valor 1 si hay que redondear y 0 si no
	tay			; lo ponemos en Y para usarlo como contador
	pla			; sacamos el sumando de la pila
	lda	VALOR_INI	; valor del primer tile de la lnea
	sep 	#$20
llena	sta	$2118		; vamos escribiendo consecutivamente $00, $02, etc porque los tiles superiores
				; ya estn ordenadas en $2000 de VRAM
	stz	$2119		; siempre cero en este registro para no hacer volteo H/V
	inc	a
	inc	a		; sumando 2 obtenemos el valor de la siguiente tile (parte superior de la letra)
	dey			; decrementamos el contador de las tiles a escribir
	cpy	#$0000		; vemos si ha llegado al final de la cuenta de tiles
	bne	llena		; si no se ha llegado, se sigue metiendo offsets
	ply			; recuperamos el valor del registro Y antes de entrar en la subrutina
	plp			; recuperamos el estado del micro antes de la subrutina
	rts



;==========================================================================
;          Mete en VRAM $2000 las tiles definitivas a sacar por pantalla 
;==========================================================================
; Una vez que ya tenemos en orden las tiles en RAM y adems les hempos aplicado el offset a las letras que lo
; requeran para ajustar su anchura, ya podemos transmitir todo en RAM tal y como est a VRAM; el nmero de
; bytes a transmitir ser de 16 bytes por cada tile y cada letra tiene 2 tiles (uno superior y otro inferior);
; por tanto el valor ser:	#NUM_TILES x 2 X 16

tiles2VRAM
	rep     #$30   		; X,Y,A fixed -> 16 bit mode
	sep     #$20   		; Accumulator ->  8 bit mode

	ldx     #$2000          ; Assign VRAM location $2000 to $2116
	stx     $2116

	lda	#$80		; se incrementa el puntero a la VRAM que est en $2116 cada vez que se
	sta	$2115		; se escriba en el registro $2119

	ldx	#!RAM_tiles	; lugar de destino en RAM de las tiles
	stx	$4302		; esta esla fuente de los datos a transmitir

	lda	#$7E		; banco de destino -> $7E es la RAM
	sta	$4304

	lda	NUM_TILES
	rep	#$20
	and	#$00FF
	asl	a
	asl	a
	asl	a
	asl	a
	asl	a
	sta	$4305
	sep	#$20

	lda	#$18		; registro de destino es el $2118/19
	sta	$4301

	lda	#$01		; configuramos la escritura de 16 bits: primer byte en $2118 y segundo en $2119
	sta	$4300

	lda	#$01
	sta	$420B		; activamos el DMA del canal 0

	rts



;==========================================================================================
; Limpiamos una zona de RAM de tamao igual a toda la pantalla (1024 celdas x 8bytes/celda) 
;==========================================================================================
limpia_RAM
	rep     #$30   		; X,Y,A fixed -> 16 bit mode
	sep     #$20   		; Accumulator ->  8 bit mode

	phb			; guarda en pila el banco de datos
	lda	#$7E
	pha			; guarda en pila el banco de RAM
	plb

	ldx	#$0000
	lda	#$00
vaciado
	sta	!RAM_tiles,x
	inx
	cpx	#$2000
	bne	vaciado

	plb
	rts



;=================================================================================
;=	 Fuente extrada y modificada por Magno del juego Chrono Trigger	 =
;=================================================================================
; Fuete de anchura variable de 107 caracteres, 16 de los cuales llevan una extensin de anchura
FUENTE_VWF
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$FE,$FC,$FE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;A = $10
	.dcb	$00,$00,$00,$00,$00,$00,$FC,$F8,$FE,$CC,$EE,$CC,$FC,$FA,$FE,$CC,$EE,$CC,$EE,$CC,$FC,$FA,$F8,$04,$00,$00,$00,$00,$00,$00,$00,$00	;B
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$C4,$E4,$C2,$E0,$C0,$E0,$C0,$E0,$C0,$E6,$C4,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;C
	.dcb	$00,$00,$00,$00,$00,$00,$FC,$F8,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$FA,$F8,$04,$00,$00,$00,$00,$00,$00,$00,$00	;D
	.dcb	$00,$00,$00,$00,$00,$00,$FC,$F8,$F8,$C4,$E0,$C0,$F8,$F0,$F0,$C8,$E0,$C0,$E0,$C0,$FC,$F8,$F8,$04,$00,$00,$00,$00,$00,$00,$00,$00	;E
	.dcb	$00,$00,$00,$00,$00,$00,$FC,$F8,$F8,$C4,$E0,$C0,$F8,$F0,$F0,$C8,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00,$00,$00	;F
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$C4,$E4,$C2,$E0,$C0,$FE,$DC,$FE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;G
	.dcb	$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FE,$FC,$FE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;H
	.dcb	$00,$00,$00,$00,$00,$00,$F8,$F0,$F0,$68,$70,$60,$70,$60,$70,$60,$70,$60,$70,$60,$F8,$F0,$F0,$08,$00,$00,$00,$00,$00,$00,$00,$00	;I
	.dcb	$00,$00,$00,$00,$00,$00,$0E,$0C,$0E,$0C,$0E,$0C,$0E,$0C,$0E,$0C,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;J
	.dcb	$00,$00,$00,$00,$00,$00,$E7,$C6,$EE,$CD,$FC,$DA,$F8,$F4,$F8,$F0,$FC,$D8,$FE,$CC,$EF,$C6,$C6,$21,$00,$00,$00,$00,$00,$00,$00,$00	;K	-> extra vaco
	.dcb	$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$FC,$F8,$F8,$04,$00,$00,$00,$00,$00,$00,$00,$00	;L
	.dcb	$00,$00,$00,$00,$00,$00,$C1,$81,$E3,$C3,$F7,$E7,$FF,$FF,$FF,$BB,$FB,$97,$D3,$8B,$C3,$83,$83,$40,$00,$00,$00,$00,$00,$00,$00,$00	;M
	.dcb	$00,$00,$00,$00,$00,$00,$C3,$82,$E3,$C2,$F3,$E2,$FB,$F2,$FF,$BA,$FF,$9E,$DF,$8E,$CF,$86,$86,$41,$00,$00,$00,$00,$00,$00,$00,$00	;N	-> extra vaco
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;O
	.dcb	$00,$00,$00,$00,$00,$00,$FC,$F8,$FE,$CC,$EE,$CC,$EE,$CC,$FC,$FA,$F8,$C4,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00,$00,$00	;P
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$7E,$0C,$0C,$02,$00,$00,$00,$00,$00,$00	;Q = $20
	.dcb	$00,$00,$00,$00,$00,$00,$FC,$F8,$FE,$CC,$EE,$CC,$EE,$CC,$FC,$FA,$FE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;R
	.dcb	$00,$00,$00,$00,$00,$00,$78,$70,$FC,$C8,$E8,$D4,$F0,$E8,$F8,$74,$7C,$38,$FC,$98,$F8,$74,$70,$08,$00,$00,$00,$00,$00,$00,$00,$00	;S
	.dcb	$00,$00,$00,$00,$00,$00,$FE,$FC,$FC,$32,$38,$30,$38,$30,$38,$30,$38,$30,$38,$30,$38,$30,$30,$08,$00,$00,$00,$00,$00,$00,$00,$00	;T
	.dcb	$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;U
	.dcb	$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EC,$CA,$F8,$F4,$F0,$08,$00,$00,$00,$00,$00,$00,$00,$00	;V
	.dcb	$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FF,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00	;W
	.dcb	$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$FE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;X
	.dcb	$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$34,$38,$30,$38,$30,$30,$08,$00,$00,$00,$00,$00,$00,$00,$00	;Y
	.dcb	$00,$00,$00,$00,$00,$00,$FE,$FC,$FE,$0C,$1E,$1C,$3C,$3A,$78,$74,$F0,$E8,$E0,$D0,$FE,$FC,$FC,$02,$00,$00,$00,$00,$00,$00,$00,$00	;Z
	.dcb	$00,$00,$1C,$18,$38,$30,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$FE,$FC,$FE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$1C,$18,$38,$30,$FC,$F8,$F8,$C4,$E0,$C0,$F8,$F0,$F0,$C8,$E0,$C0,$E0,$C0,$FC,$F8,$F8,$04,$00,$00,$00,$00,$00,$00,$00,$00	;ɒ
	.dcb	$00,$00,$1C,$18,$38,$30,$F8,$F0,$F0,$68,$70,$60,$70,$60,$70,$60,$70,$60,$70,$60,$F8,$F0,$F0,$08,$00,$00,$00,$00,$00,$00,$00,$00	;͒
	.dcb	$00,$00,$1C,$18,$38,$30,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;Ӓ
	.dcb	$00,$00,$1C,$18,$38,$30,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;ڒ
	.dcb	$00,$00,$70,$60,$38,$30,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$FE,$FC,$FE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$70,$60,$38,$30,$FC,$F8,$F8,$C4,$E0,$C0,$F8,$F0,$F0,$C8,$E0,$C0,$E0,$C0,$FC,$F8,$F8,$04,$00,$00,$00,$00,$00,$00,$00,$00	; = $30
	.dcb	$00,$00,$0A,$34,$26,$58,$C3,$82,$E3,$C2,$F3,$E2,$FB,$F2,$FF,$BA,$FF,$9E,$DF,$8E,$CF,$86,$86,$41,$00,$00,$00,$00,$00,$00,$00,$00	;ђ	-> extra vaco
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$C4,$E4,$C2,$E0,$C0,$E0,$C0,$E0,$C0,$FE,$D4,$FC,$7A,$78,$14,$1C,$18,$0C,$08,$18,$10,$00,$00	;ǒ
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$8C,$FE,$7C,$FE,$CC,$EE,$CC,$FE,$7C,$7C,$02,$00,$00,$00,$00,$00,$00,$00,$00	;a
	.dcb	$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$FC,$F8,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$FA,$F8,$04,$00,$00,$00,$00,$00,$00,$00,$00	;b
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$78,$70,$FC,$C8,$E8,$C4,$E0,$C0,$EC,$C8,$F8,$74,$70,$08,$00,$00,$00,$00,$00,$00,$00,$00	;c
	.dcb	$00,$00,$00,$00,$00,$00,$0E,$0C,$0E,$0C,$7E,$7C,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FE,$7C,$7C,$02,$00,$00,$00,$00,$00,$00,$00,$00	;d
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$CC,$FE,$FC,$FC,$C2,$E6,$C4,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;e
	.dcb	$00,$00,$00,$00,$00,$00,$3C,$38,$78,$64,$F8,$F0,$F0,$68,$70,$60,$70,$60,$70,$60,$70,$60,$60,$10,$00,$00,$00,$00,$00,$00,$00,$00	;f
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7E,$7C,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FE,$7C,$7E,$0C,$CE,$8C,$FC,$7A,$78,$04,$00,$00	;g
	.dcb	$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$FC,$F8,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;h
	.dcb	$00,$00,$00,$00,$00,$00,$E0,$C0,$C0,$20,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00,$00,$00	;i
	.dcb	$00,$00,$00,$00,$00,$00,$1C,$18,$18,$04,$1C,$18,$1C,$18,$1C,$18,$1C,$18,$1C,$18,$1C,$18,$1C,$18,$DC,$98,$F8,$74,$70,$08,$00,$00	;j
	.dcb	$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$FC,$D8,$F8,$F4,$F0,$E8,$F8,$F0,$F8,$D8,$FC,$CC,$CC,$20,$00,$00,$00,$00,$00,$00,$00,$00	;k
	.dcb	$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00,$00,$00	;l
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FF,$FF,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;m
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FC,$F8,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;n = $40
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;o
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FC,$F8,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$FA,$F8,$C4,$E0,$C0,$C0,$20,$00,$00,$00,$00	;p
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$7E,$7C,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FE,$7C,$7E,$0C,$0E,$0C,$0C,$02,$00,$00,$00,$00	;q
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FC,$D8,$F8,$E4,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00,$00,$00	;r
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$78,$70,$FC,$C8,$F8,$64,$78,$30,$FC,$98,$F8,$74,$70,$08,$00,$00,$00,$00,$00,$00,$00,$00	;s
	.dcb	$00,$00,$00,$00,$00,$00,$70,$60,$70,$60,$F8,$F0,$F0,$60,$70,$60,$70,$60,$70,$60,$78,$30,$30,$08,$00,$00,$00,$00,$00,$00,$00,$00	;t
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FE,$7C,$7C,$02,$00,$00,$00,$00,$00,$00,$00,$00	;u
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EC,$CA,$F8,$F4,$F0,$08,$00,$00,$00,$00,$00,$00,$00,$00	;v
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FF,$FF,$FF,$00,$00,$00,$00,$00,$00,$00,$00,$00	;w
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$FC,$7A,$FE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;x
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FE,$7C,$7E,$0C,$CE,$AC,$FC,$7A,$78,$04,$00,$00	;y
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FE,$FC,$FC,$1A,$38,$34,$70,$68,$E0,$D0,$FE,$FC,$FC,$02,$00,$00,$00,$00,$00,$00,$00,$00	;z
	.dcb	$00,$00,$00,$00,$1C,$18,$38,$30,$00,$00,$7C,$78,$FE,$8C,$FE,$7C,$FE,$CC,$EE,$CC,$FE,$7C,$7C,$02,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$1C,$18,$38,$30,$00,$00,$7C,$78,$FE,$CC,$FE,$FC,$FC,$C2,$E6,$C4,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$60,$60,$E0,$C0,$C0,$20,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$1C,$18,$38,$30,$00,$00,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	; = $50
	.dcb	$00,$00,$00,$00,$1C,$18,$38,$30,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FE,$7C,$7C,$02,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$70,$60,$38,$30,$00,$00,$7C,$78,$FE,$8C,$FE,$7C,$FE,$CC,$EE,$CC,$FE,$7C,$7C,$02,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$70,$60,$38,$30,$00,$00,$7C,$78,$FE,$CC,$FE,$FC,$FC,$C2,$E6,$C4,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$14,$68,$4C,$B0,$00,$00,$FC,$F8,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$78,$70,$FC,$C8,$E8,$C4,$E0,$C0,$FC,$C8,$F8,$74,$70,$20,$28,$30,$18,$10,$30,$20,$00,$00	;
	.dcb	$00,$00,$00,$00,$00,$00,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$CC,$22,$00,$00,$00,$00,$00,$00,$00,$00	;ll
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;0
	.dcb	$00,$00,$00,$00,$00,$00,$70,$60,$F0,$E0,$F0,$60,$70,$60,$70,$60,$70,$60,$70,$60,$70,$60,$60,$00,$00,$00,$00,$00,$00,$00,$00,$00	;1
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$8C,$8E,$4C,$0E,$0C,$1C,$1A,$38,$34,$70,$68,$FE,$FC,$FC,$02,$00,$00,$00,$00,$00,$00,$00,$00	;2
	.dcb	$00,$00,$00,$00,$00,$00,$FE,$FC,$FC,$1A,$38,$34,$7C,$78,$7E,$0C,$0E,$0C,$CE,$8C,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;3
	.dcb	$00,$00,$00,$00,$00,$00,$0E,$0C,$1E,$1C,$3E,$2C,$6E,$5C,$CE,$AC,$FF,$FE,$FE,$0D,$0E,$0C,$0C,$02,$00,$00,$00,$00,$00,$00,$00,$00	;4
	.dcb	$00,$00,$00,$00,$00,$00,$FE,$FC,$FC,$C2,$E0,$C0,$FC,$F8,$FE,$0C,$0E,$0C,$CE,$8C,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;5
	.dcb	$00,$00,$00,$00,$00,$00,$3C,$38,$78,$64,$E0,$D0,$FC,$F8,$FE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;6
	.dcb	$00,$00,$00,$00,$00,$00,$FE,$FC,$FE,$0C,$0E,$0C,$0E,$0C,$1C,$1A,$38,$34,$38,$30,$38,$30,$30,$08,$00,$00,$00,$00,$00,$00,$00,$00	;7
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$CC,$EE,$CC,$FC,$7A,$FE,$CC,$EE,$CC,$EE,$CC,$FC,$7A,$78,$04,$00,$00,$00,$00,$00,$00,$00,$00	;8
	.dcb	$00,$00,$00,$00,$00,$00,$7C,$78,$FE,$CC,$EE,$CC,$EE,$CC,$FE,$7C,$7E,$0C,$1C,$1A,$78,$74,$70,$08,$00,$00,$00,$00,$00,$00,$00,$00	;9 = $60
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; 
	.dcb	$00,$00,$00,$00,$E0,$C0,$E0,$C0,$00,$00,$C0,$20,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00	;!
	.dcb	$00,$00,$00,$00,$38,$30,$38,$30,$30,$08,$38,$30,$38,$30,$70,$60,$E0,$C0,$E4,$C8,$E2,$C4,$7C,$78,$38,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$7C,$78,$FE,$8C,$8E,$4C,$0E,$0C,$1C,$1A,$38,$34,$38,$30,$30,$08,$38,$30,$38,$30,$30,$08,$00,$00,$00,$00,$00,$00	;?
	.dcb	$00,$00,$00,$00,$30,$20,$60,$50,$C0,$A0,$C0,$80,$C0,$80,$C0,$80,$C0,$80,$C0,$80,$E0,$40,$70,$20,$20,$10,$00,$00,$00,$00,$00,$00	;(
	.dcb	$00,$00,$00,$00,$C0,$80,$E0,$40,$70,$20,$30,$20,$30,$20,$30,$20,$30,$20,$30,$20,$60,$50,$C0,$A0,$80,$40,$00,$00,$00,$00,$00,$00	;)
	.dcb	$00,$00,$00,$00,$00,$00,$7E,$6C,$7E,$6C,$6C,$5A,$7E,$24,$24,$12,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$00,$00,$7E,$6C,$7E,$6C,$7E,$24,$6C,$5A,$48,$24,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$18,$10,$18,$10,$18,$10,$FF,$FE,$FE,$11,$18,$10,$18,$10,$10,$08,$00,$00,$00,$00,$00,$00,$00,$00	;+
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FE,$FC,$FE,$02,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	;-
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$FE,$FE,$01,$FF,$FE,$FE,$01,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	;=
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00,$00,$00	;.
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$E0,$40,$C0,$A0,$80,$40,$00,$00,$00,$00	;,
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$E0,$C0,$E0,$C0,$E0,$40,$C0,$A0,$80,$40,$00,$00	;;
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	;: = $70
	.dcb	$00,$00,$00,$00,$00,$00,$30,$20,$30,$20,$30,$20,$60,$50,$60,$40,$60,$40,$C0,$A0,$C0,$80,$C0,$80,$00,$00,$00,$00,$00,$00,$00,$00	;/
	.dcb	$00,$00,$00,$00,$3C,$28,$7E,$7C,$FF,$EE,$FF,$AA,$FC,$E8,$7E,$7C,$3F,$2E,$FF,$AA,$FF,$EE,$7E,$7C,$3C,$28,$00,$00,$00,$00,$00,$00	;$
	.dcb	$00,$00,$00,$00,$00,$00,$3C,$38,$7E,$6C,$7E,$6C,$3C,$38,$7F,$76,$FE,$DC,$EE,$CC,$EE,$CC,$7F,$76,$00,$00,$00,$00,$00,$00,$00,$00	;&	-> extra vaco
	.dcb	$00,$00,$00,$00,$00,$00,$66,$44,$66,$44,$FF,$FE,$66,$44,$66,$44,$66,$44,$FF,$FE,$66,$44,$66,$44,$00,$00,$00,$00,$00,$00,$00,$00	;#	-> extra vaco
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$3F,$3E,$7F,$63,$EF,$CF,$FF,$DB,$FF,$DB,$EF,$CE,$7F,$61,$3F,$3E,$00,$00,$00,$00,$00,$00,$00,$00	;@
	.dcb	$00,$00,$00,$00,$00,$00,$02,$03,$03,$03,$03,$02,$03,$02,$03,$02,$03,$02,$03,$02,$03,$02,$0F,$0E,$1F,$1E,$1E,$1D,$0C,$12,$00,$00	;nota'
	.dcb	$00,$00,$00,$00,$00,$00,$01,$01,$19,$11,$3F,$2A,$3B,$16,$16,$0D,$06,$04,$0D,$0B,$0D,$08,$08,$04,$00,$00,$00,$00,$00,$00,$00,$00	;%
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$FF,$DB,$FF,$DB,$DB,$24,$00,$00,$00,$00,$00,$00,$00,$00	;...
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$79,$71,$BF,$CA,$CE,$85,$C6,$84,$CF,$8A,$FB,$75,$71,$08,$00,$00,$00,$00,$00,$00	;inf
	.dcb	$00,$00,$00,$00,$19,$11,$3F,$2A,$6E,$55,$64,$42,$60,$40,$20,$70,$31,$19,$1B,$0E,$0E,$05,$04,$02,$00,$00,$00,$00,$00,$00,$00,$00	;'corazn = $7A'
	.dcb	$00,$00,$00,$00,$00,$00,$80,$00,$80,$00,$80,$00,$80,$00,$80,$00,$80,$00,$80,$00,$80,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00	;M_extra ($0D60)
	.dcb	$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$A0,$80,$40,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00	;W_extra ($0D80)
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$C0,$80,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$20,$00,$00,$00,$00,$00,$00,$00,$00	;m_extra ($0DA0)
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$E0,$C0,$E0,$C0,$E0,$C0,$E0,$C0,$C0,$A0,$80,$40,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00	;w_extra ($0DC0)
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	;
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$00,$80,$00,$80,$00,$80,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00 ;@_extra ($0E00)
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$80,$80,$C0,$C0,$A0,$E0,$40,$60,$40,$C0,$A0,$80,$40,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00	;nota_extra($0E20)
	.dcb	$00,$00,$00,$00,$00,$00,$80,$00,$80,$00,$00,$80,$00,$00,$00,$00,$80,$80,$C0,$40,$C0,$80,$80,$40,$00,$00,$00,$00,$00,$00,$00,$00	;%_extra   ($0E40)
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$00,$80,$00,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00	;..._extra ($0E60)
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$E0,$C0,$F0,$20,$30,$20,$30,$20,$30,$20,$E0,$D0,$C0,$20,$00,$00,$00,$00,$00,$00	;inf_extra ($0E80)
	.dcb	$00,$00,$00,$00,$80,$00,$C0,$80,$60,$40,$60,$40,$60,$40,$C0,$A0,$00,$40,$00,$80,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	;'corazn_extra'($0EA0)
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00	; vaco		($0EC0)


TABLA_VWF;	'AB'	'EF'	'IJ'	'MN'	'QR'	'UV'	'YZ'	''    ''
	.dcb	$00,$00,$11,$00,$20,$91,$A9,$00,$00,$10,$00,$C0,$00,$01,$20,$00,$19,$00

	;	'bc'	'fg'	'jk'	'no'	'rs'	'vw'	'z'	''	''
	.dcb	$01,$00,$10,$04,$11,$4C,$00,$00,$11,$20,$0C,$00,$00,$04,$00,$00,$01

	;	'll0'	'34'	'78'
	.dcb	$00,$30,$01,$00,$00,$01

	;	'!'	'()'	'+-'	',;'	'$&'	'%'	'corazon'
	.dcb	$44,$00,$33,$00,$90,$94,$44,$43,$99,$9A,$DC,$AD,$C0


TABLA_EXTRA;							'W_xtra'			'K_xtra'	'M_xtra''N_xtra'	
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$0D,$00,$00,$00,$00,$00,$00,$C0,$0E,$00,$00,$60,$0D,$C0,$0E,$00,$00,$00,$00
;			'_xtra'							'w_xtra'					'm_xtra'
	.dcb	$00,$00,$C0,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$C0,$0D,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$A0,$0D
;												'+_xtra'	'=_xtra'
	.dcb	$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$C0,$0E,$00,$00,$C0,$0E,$00,$00,$00,$00,$00,$00
;				'$_xtra''&_xtra''#_xtra''@_xtra''not_xt''%_xtra''..._xt''inf_xt''cor_xt'
	.dcb	$00,$00,$00,$00,$C0,$0E,$C0,$0E,$C0,$0E,$00,$0E,$20,$0E,$40,$0E,$60,$0E,$80,$0E,$A0,$0E,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00



PRESENTACION
	.dcb	$14,$80,$41,$61,$8B,$E4,$42,$44,$83,$34,$33,$61,$A1,$8C,$33,$05
	.dcb	$38,$47,$C9,$61,$25,$26,$15,$61,$CE,$61,$3E,$33,$61,$22,$47,$42,$37,$44,$05
	.dcb	$1D,$3B,$40,$46,$37,$40,$36,$41,$6F,$61,$45,$3B,$61,$3E,$33,$61,$42,$44,$83,$34,$33,$61,$8B,$05
	.dcb	$45,$33,$46,$3B,$45,$38,$33,$35,$46,$41,$44,$3B,$33,$6E,$61,$3E,$33,$61,$47,$45,$33,$44,$4E,$61,$37,$40,$05
	.DCB	$38,$47,$46,$47,$44,$41,$45,$61,$42,$44,$41,$4B,$37,$35,$8D,$45,$78,$00

CHAR_SET	
	.dcb	$10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,$05
	.dcb	$20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,$05
	.dcb	$30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F,$05
	.dcb	$40,$41,$42,$43,$44,$45,$46,$47,$48,$49,$4A,$4B,$4C,$4D,$4E,$4F,$05
	.dcb	$50,$51,$52,$53,$54,$55,$56,$57,$58,$59,$5A,$5B,$5C,$5D,$5E,$5F,$05
	.dcb	$60,$61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D,$6E,$6F,$05
	.dcb	$70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A,$00

DESPEDIDA
	.dcb	$72,$72,$61,$68,$23,$21,$10,$13,$24,$12,$12,$18,$1E,$1D,$14,$22,$61
	.dcb	$1C,$10,$16,$1D,$1E,$61,$61,$59,$57,$57,$5A,$69,$61,$72,$72,$05
	.dcb	$61,$46,$44,$33,$36,$47,$35,$35,$3B,$41,$40,$37,$45,$6D,$3F,$33,$39,$40,$41,$75,$33,$40,$39,$37,$3E,$38,$3B,$44,$37,$6D,$35,$41,$3F,$00


MTE
	.dcb	$45,$46			; %1XX0 0000 -> $80 "st"
	.dcb	$36,$37,$61		; %1XX0 0001 -> $A1 "de "
	.dcb	$00			; padding para que las entradas MTE queden alineadas en direcciones pares
	.dcb	$47,$37			; %1XX0 0011 -> $83 "ue"
	.dcb	$61,$47,$40,$33,$61	; %1XX0 0100 -> $E4 " una "
	.dcb	$00			; padding para que las entradas MTE queden alineadas en direcciones pares
	.dcb	$61,$36,$37,$61		; %1XX0 0111 -> $C7 " de "
	.dcb	$37,$40,$46,$37		; %1XX0 1001 -> $C9 "ente"
	.dcb	$37,$45			; %1XX0 1011 -> $8B "es"
	.dcb	$47,$40			; %1XX0 1100 -> $8C "un"
	.dcb	$46,$41			; %1XX0 1101 ->	$8D "to"
	.dcb	$42,$33,$44,$33		; %1XX0 1110 -> $CE "para"
	.dcb	$3E,$33			; %1XX1 0000 -> $8E "la"
	.dcb	""	; %1XX1 0001
	.dcb	""	; %1XX1 0010
	.dcb	""	; %1XX1 0011
	.dcb	""	; %1XX1 0100
	.dcb	""	; %1XX1 0101
	.dcb	""	; %1XX1 0110
	.dcb	""	; %1XX1 0111
	.dcb	""	; %1XX1 1000
	.dcb	""	; %1XX1 1001
	.dcb	""	; %1XX1 1010
	.dcb	""	; %1XX1 1011
	.dcb	""	; %1XX1 1100
	.dcb	""	; %1XX1 1101
	.dcb	""	; %1XX1 1110
	.dcb	""	; %1XX1 1111

	.interrupts
  	reset           =       $008000
        .end
